--Delete duplicate objects in the IPS domain (http://TaskManager/TaskView.asp?TaskId=81053)
--After running this script, deleting the CRC markers DB and running full IPS update is needed

alter table dleobjectderef_data disable trigger all;
alter table link_data disable trigger all;



--Delete one of each duplicate objects in the IPS domain if it does not have any refernces to it.
--(If one have refernces and the other does not, the one without the refernces will be removed)
update dleobjectderef_data set deleted=true where dlesession=0 and deleted=false and objid in (
select DISTINCT ON(name) objid from dleobjectderef_data where (name,objclass) in (
select name,objclass from dleobjectderef_data where domainid='a0bbbc99-adef-4ef8-bb6d-cebcebcebceb' and dlesession=0 and deleted=false group by name,objclass having count(name)>1
) and toversion='2147483647' and objid not in( select destinationobjectid from link_data where dlesession=0 and deleted=false and domainid='a0bbbc99-adef-4ef8-bb6d-cebcebcebceb' )
order by name, fromversion DESC
);


--In case we still have duplications in the DB (in case there are links to both of the duplicated objects), delete all the links to the duplicate objects
update link_data set deleted=true where destinationobjectid in (
select objid from dleobjectderef_data where (name,objclass) in (
select name,objclass from dleobjectderef_data where domainid='a0bbbc99-adef-4ef8-bb6d-cebcebcebceb' and dlesession=0 and deleted=false group by name,objclass having count(name)>1
) and dlesession=0 and deleted=false ) and dlesession=0 and deleted=false ;



--After the links were removed, delete one of each duplicate object
update dleobjectderef_data set deleted=true where dlesession=0 and deleted=false and objid in (
select DISTINCT ON(name) objid from dleobjectderef_data where (name,objclass) in (
select name,objclass from dleobjectderef_data where domainid='a0bbbc99-adef-4ef8-bb6d-cebcebcebceb' and dlesession=0 and deleted=false group by name,objclass having count(name)>1
) and toversion='2147483647' and objid not in( select destinationobjectid from link_data where dlesession=0 and deleted=false and domainid='a0bbbc99-adef-4ef8-bb6d-cebcebcebceb' )
order by name, fromversion DESC);


alter table dleobjectderef_data enable trigger all;
alter table link_data enable trigger all;
